@LIST-KOP = ML-LISTING
@LIST_ML = 	ORG &HA000
@LIST_ML = 
@LIST_ML = ;Get Stick and Triggers (GTSTTR)
@LIST_ML = ;In: A = Stick# : 0 = keyboard
@LIST_ML = ;                 1 = joystick 1
@LIST_ML = ;                 2 = joystick 2
@LIST_ML = ;Out: A = Steering direction (0-8)
@LIST_ML = ;     C = trigger A (0 = not pressed, 1 = pressed)
@LIST_ML = ;     B = trigger B (0 = not pressed, 1 = pressed)
@LIST_ML = ;Uses: F,H,L
@LIST_ML = ;Note: PSGREG and PPIPRC won't be affected
@LIST_ML = 
@LIST_ML = PSGREG: EQU &HA0	;PSG REGister pointer port#
@LIST_ML = PSGWDT: EQU &HA1	;PSG Write DaTa into register port#
@LIST_ML = PSGRDT: EQU &HA2	;PSG Read DaTa from register port#
@LIST_ML = 
@LIST_ML = PPIPRB: EQU &HA9	;PPI PoRt B
@LIST_ML = PPIPRC: EQU &HAA	;PPI PoRt C
@LIST_ML = 
@LIST_ML = GTSTTR:   ; Goede Tijden Slechte Tijden Televisie Rotzooi? :)
@LIST_ML = 
@LIST_ML = 	DI
@LIST_ML = 
@LIST_ML = ;which stick?
@LIST_ML = 	AND A
@LIST_ML = 	JP Z,JUMP
@LIST_ML = 
@LIST_ML = ;get stick 1 or 2
@LIST_ML = 	CPL
@LIST_ML = 	AND &B00000001	;reposition bit#0
@LIST_ML = 	RRCA
@LIST_ML = 	RRCA
@LIST_ML = 	LD B,A
@LIST_ML = 	LD C,PSGREG	;store current contents in H
@LIST_ML = 	IN H,(C)
@LIST_ML = 	LD A,15	;PSG register #15
@LIST_ML = 	OUT (C),A
@LIST_ML = 	IN A,(PSGRDT)	;set active joystick
@LIST_ML = 	AND &B10111111
@LIST_ML = 	OR B
@LIST_ML = 	OUT (PSGWDT),A
@LIST_ML = 	LD A,14	;PSG regsister #14
@LIST_ML = 	OUT (C),A	;get joystick status
@LIST_ML = 	IN A,(PSGRDT)	;A = steering direction + triggers
@LIST_ML = 	OUT (C),H	;reset register pointer
@LIST_ML = 
@LIST_ML = ;calculate STEERING DIRECTION
@LIST_ML = 	LD L,A	;keep a copy in L
@LIST_ML = 	AND &B00001111
@LIST_ML = 	LD C,A
@LIST_ML = 	LD B,0
@LIST_ML = 	LD A,L	;shift copy back to A
@LIST_ML = 	LD HL,DIRTBJ
@LIST_ML = 	ADD HL,BC	;HL points at Steering Direction
@LIST_ML = 
@LIST_ML = ;calculate TRIGGER B
@LIST_ML = 	CPL	;(negative logic)
@LIST_ML = 	AND &B00110000	;use copy in A
@LIST_ML = 	ADD A,A
@LIST_ML = 	ADD A,A
@LIST_ML = 	ADD A,A	;Cy = trigger B
@LIST_ML = 	RL B
@LIST-VOET = GET_JOY.ASM <F129M><188><F255D>
@LIST-KOP = <F129M><188><F255D> ML-LISTING
@LIST_ML = ;calculate TRIGGER A
@LIST_ML = 	RLCA
@LIST_ML = 	LD C,A
@LIST_ML = 	LD A,(HL)	;A = Steering Direction
@LIST_ML = 
@LIST_ML = 	EI
@LIST_ML = 
@LIST_ML = 	RET
@LIST_ML = 
@LIST_ML = ;DIRection TaBle for Joy-sticks
@LIST_ML = DIRTBJ: DEFB 0,0,0,0,0,4,2,3,0,6,8,7,0,5,1,0
@LIST_ML = 
@LIST_ML = ;get stick 0
@LIST_ML = JUMP:
@LIST_ML = 	IN A,(PPIPRC)	;store current contents in H
@LIST_ML = 	LD H,A
@LIST_ML = 	AND &B11110000	;reset column bits only
@LIST_ML = 	LD L,A
@LIST_ML = 
@LIST_ML = ;calculate TRIGGER B
@LIST_ML = 	OR 6	;read column 6
@LIST_ML = 	OUT (PPIPRC),A
@LIST_ML = 	IN A,(PPIPRB)
@LIST_ML = 	LD C,&B00000001	;C= bitmask,
@LIST_ML = 		;(sorry about that C64 logo) :)
@LIST_ML = 	AND C
@LIST_ML = 	XOR C	;(negative logic)
@LIST_ML = 	LD B,A
@LIST_ML = 
@LIST_ML = ;calculate TRIGGER A
@LIST_ML = 	LD A,8	;read column 8
@LIST_ML = 	OR L
@LIST_ML = 	OUT (PPIPRC),A
@LIST_ML = 	IN A,(PPIPRB)
@LIST_ML = 	LD L,A	;keep a copy in L
@LIST_ML = 	AND C
@LIST_ML = 	XOR C	;(negative logic)
@LIST_ML = 	LD C,A
@LIST_ML = 	PUSH BC	;save triggers
@LIST_ML = 
@LIST_ML = ;calculate STEERING DIRECTION
@LIST_ML = 	LD A,&B11110000	;use copy in L
@LIST_ML = 	AND L
@LIST_ML = 	RRCA
@LIST_ML = 	RRCA
@LIST_ML = 	RRCA
@LIST_ML = 	RRCA
@LIST_ML = 	LD C,A
@LIST_ML = 	LD B,0
@LIST_ML = 	LD A,H	;shift original contents to A
@LIST_ML = 	LD HL,DIRTBC
@LIST_ML = 	ADD HL,BC	;HL points at Steering Direction
@LIST_ML = 	OUT (PPIPRC),A	;reset register with original value
@LIST_ML = 	LD A,(HL)	;wop in accum.
@LIST_ML = 	POP BC
@LIST_ML = 
@LIST_ML = 	EI
@LIST_ML = 
@LIST_ML = 	RET
@LIST_ML = 
@LIST_ML = ;DIRection TaBle for Cursor
@LIST_ML = DIRTBC: DEFB 0,3,5,4,1,2,0,3,7,0,6,5,8,1,7,0
@LIST-VOET =  GET_JOY.ASM
